package org.kasapbasi.tutorials.w0904;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Color;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import android.support.annotation.Nullable;
import android.util.AttributeSet;
import android.widget.TextView;


/**
 * Created by mustafakasapbasi on 12/04/2017.
 */



public class TimeView extends android.support.v7.widget.AppCompatTextView {
    private String titleText;
    private boolean color;

    public TimeView(Context context) {
        super(context);
        setTimeView();
    }

    public TimeView(Context context, AttributeSet attrs) {
        super(context, attrs);
        // retrieved values correspond to the positions of the attributes
        TypedArray typedArray = context.obtainStyledAttributes(attrs,
                R.styleable.TimeView);
        int count = typedArray.getIndexCount();
        try{

            for (int i = 0; i < count; ++i) {

                int attr = typedArray.getIndex(i);
                // the attr corresponds to the title attribute
                if(attr == R.styleable.TimeView_title) {

                    // set the text from the layout
                    titleText = typedArray.getString(attr);
                    setTimeView();
                } else if(attr == R.styleable.TimeView_setColor) {
                    // set the color of the attr "setColor"
                    color = typedArray.getBoolean(attr, false);
                    decorateText();
                }
            }
        }

        // the recycle() will be executed obligatorily
        finally {
            // for reuse
            typedArray.recycle();
        }
    }

    public TimeView(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        setTimeView();
    }

    @Override
    public void setText(CharSequence text, BufferType type) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("hh.mm aa");
        String time = dateFormat.format(Calendar.getInstance().getTime());

        super.setText(text + time , type);

    }

    private void setTimeView() {
        // has the format hour.minuits am/pm
        SimpleDateFormat dateFormat = new SimpleDateFormat("hh.mm aa");
        String time = dateFormat.format(Calendar.getInstance().getTime());

       // if(this.titleText != null )
         //   setText(this.titleText+" "+time);
        //else
            setText(getText().toString()+ time);
    }

    private void decorateText() {
        // when we set setColor attribute to true in the XML layout
        if(this.color == true){
            // set the characteristics and the color of the shadow
            setShadowLayer(4, 2, 2, Color.rgb(0, 0, 0));
            setBackgroundColor(Color.CYAN);
        } else {
            setBackgroundColor(Color.RED);
        }
    }
}
